Summary: packet-sniffer/logger
Name: snort-sguil
%define realname snort
Version: 2.1.3
Release: fc2_1
Copyright: GPL
Group: Applications/Internet
Source0: http://www.snort.org/Files/%{realname}-%{version}.tar.gz
Source1: snort-stat
Source2: snortlog
Source4: snortd
#Patch0: snort.configure.patch
Patch1: snort.conf.patch
Patch2: spp_portscan_sguil.patch
Patch3: spp_stream4_sguil.patch
Url: http://www.snort.org
BuildRoot: /var/tmp/%{name}-root
Prefix: /usr
Packager: Ralf Spenneberg <ralf@spenneberg.de> - OpenSource Security

%description
Snort is a libpcap-based packet sniffer/logger which 
can be used as a lightweight network intrusion detection system. 
It features rules based logging and can perform protocol analysis, 
content searching/matching and can be used to detect a variety of 
attacks and probes, such as buffer overflows, stealth port scans, 
CGI attacks, SMB probes, OS fingerprinting attempts, and much more. 
Snort has a real-time alerting capabilty, with alerts being sent to syslog, 
a seperate "alert" file, or as a WinPopup message via Samba's smbclient
This package has been compiled with Postgresql and Mysql Support.
Keep in mind though, that all these plugins eat performance!

%prep
%setup -q -n "snort-%{version}"
#%patch0 -p1 -b configure.in
cd etc
%patch1 
cd ../src/preprocessors
patch spp_portscan.c < $RPM_SOURCE_DIR/spp_portscan_sguil.patch
patch spp_stream4.c < $RPM_SOURCE_DIR/spp_stream4_sguil.patch

%build
#autoconf
./configure --prefix=/usr --bindir=/usr/sbin --sysconfdir=/etc/snort  --with-postgresql --with-mysql --with-openssl  
#aclocal
#automake
make

%install
if [ "$RPM_BUILD_ROOT" = "/var/tmp/%{name}-root" ]; then
	rm -rf $RPM_BUILD_ROOT
        mkdir -p $RPM_BUILD_ROOT/usr/share/man/man8
	mkdir -p $RPM_BUILD_ROOT/usr/bin
	mkdir -p $RPM_BUILD_ROOT/usr/sbin
	mkdir -p $RPM_BUILD_ROOT/usr/doc
	mkdir -p $RPM_BUILD_ROOT/etc/snort
	mkdir -p $RPM_BUILD_ROOT/var/log/snort/archive
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
        cp snort.8 $RPM_BUILD_ROOT/usr/share/man/man8
	make prefix=$RPM_BUILD_ROOT/usr bindir=$RPM_BUILD_ROOT/usr/sbin sysconfdir=$RPM_BUILD_ROOT/etc/snort install
	cd rules
	install \
attack-responses.rules \
backdoor.rules \
bad-traffic.rules \
chat.rules \
ddos.rules \
deleted.rules \
dns.rules \
dos.rules \
exploit.rules \
experimental.rules \
finger.rules \
ftp.rules \
icmp-info.rules \
icmp.rules \
imap.rules \
info.rules \
local.rules \
misc.rules \
multimedia.rules \
mysql.rules \
netbios.rules \
nntp.rules \
oracle.rules \
other-ids.rules \
p2p.rules \
policy.rules \
pop2.rules \
pop3.rules \
porn.rules \
rpc.rules \
rservices.rules \
scan.rules \
shellcode.rules \
smtp.rules \
snmp.rules \
sql.rules \
telnet.rules \
tftp.rules \
virus.rules \
web-attacks.rules \
web-cgi.rules \
web-client.rules \
web-coldfusion.rules \
web-frontpage.rules \
web-iis.rules \
web-misc.rules \
web-php.rules \
x11.rules \
	 $RPM_BUILD_ROOT/etc/snort
	cd ..
	install etc/* $RPM_BUILD_ROOT/etc/snort
	install %{SOURCE1} $RPM_BUILD_ROOT/usr/bin
	install %{SOURCE2} $RPM_BUILD_ROOT/usr/bin
	install %{SOURCE4} $RPM_BUILD_ROOT/etc/rc.d/init.d
	install contrib/create_mysql $RPM_BUILD_ROOT/etc/snort
	install contrib/create_oracle.sql $RPM_BUILD_ROOT/etc/snort
	install contrib/create_postgresql $RPM_BUILD_ROOT/etc/snort
else
	echo Invalid Build root
	exit 1
fi
rm -rf $RPM_BUILD_ROOT/usr/man 

%clean
if [ "$RPM_BUILD_ROOT" = "/var/tmp/%{name}-root" ]; then
	rm -rf $RPM_BUILD_ROOT
else
	echo Invalid Build root
	exit 1
fi

%pre
grep -q sguil /etc/passwd || useradd -M -r -d /var/log/snort -s /bin/false -c "Sguil-Snort" sguil 2> /dev/null || true

						
%post
#don't do all this stuff if we are upgrading
if [ $1 = 1 ] ; then
useradd -M -r -d /var/log/snort -s /bin/false -c "Sguil-Snort" sguil 2> /dev/null || true
groupadd -r sguil 2> /dev/null || true
#/sbin/chkconfig --add snortd
fi
chown sguil /var/log/snort
chown sguil /etc/snort/*

%preun
/etc/rc.d/init.d/snortd stop
if [ $1 = 0 ] ; then
/sbin/chkconfig --del snortd
fi

%postun
#only if we are removing, not upgrading..
if [ $1 = 0 ] ; then
userdel sguil 2> /dev/null || true
groupdel sguil 2> /dev/null || true
fi

%files
%defattr(-,snort,root)
%doc COPYING ChangeLog LICENSE doc/*
/usr/share/man/man8
%attr(755,snort,root)       /usr/sbin/*
%attr(755,snort,root) 	   /usr/bin/*
%attr(750,snort,wheel)  %dir /var/log/snort
%attr(750,snort,wheel)  %dir /var/log/snort/archive
%attr(640,snort,wheel) %config(noreplace)     /etc/snort/*
%attr(750,snort,root)   /etc/rc.d/init.d/snortd

%changelog
* Mon Sep 06 2004 Ralf Spenneberg <ralf@spenneberg.net>
- created patched snort for Sguil

* Mon Aug 04 2003 Ralf Spenneberg <ralf@spenneberg.net>
- Upgraded to 2.0.1

* Sun Apr 13 2003 Ralf Spenneberg <ralf@spenneberg.de>
- Changed numbering Scheme to show RedHat 8.0

* Tue Mar 04 2003 Ralf Spenneberg <ralf@spenneberg.de>
- Moved to snort 1.9.1 because of a security hole in the RPC decode

* Tue Oct 22 2002 Ralf Spenneberg <ralf@spenneberg.de>
- Moved to snort 1.9
- Built on RedHat 8.0

* Mon Apr 05 2002 Ralf Spenneberg <ralf@spenneberg.de>
- Moved to snort 1.8.4

* Mon Aug 13 2001 Ralf Spenneberg <ralf@spenneberg.de>
- Added Mysql/Postgresql Support

* Thu Jul 12 2001 Marion Bates <mbates@ists.dartmouth.edu>
- Updated source to 1.8p1. 
- Fixed syntax problem (bad square brackets) with DNS servers in snort.conf.
- Changed process to use and slightly alter stock snort.conf file, instead of creating from scratch.

* Wed Jul 11 2001 William Stearns <wstearns@pobox.com>
- Updated source to 1.8-RELEASE, will later shoot Marty for using -RELEASE.
- Use new X-rules config files instead of old X-lib files

* Sat Jan 06 2001 Wim Vandersmissen <wim@bofh.be>
- Updated to version 1.7
- Some minor changes to snort.conf (uses default ruleset instead of vision rules)

* Tue Jul 25 2000 Wim Vandersmissen <wim@bofh.st>
- Added some checks to find out if we're upgrading or removing the package

* Sat Jul 22 2000 Wim Vandersmissen <wim@bofh.st>
- Updated to version 1.6.3
- Fixed the user/group stuff (moved to %post)
- Added userdel/groupdel to %postun
- Automagically adds the right IP, nameservers to /etc/snort/rules.base

* Sat Jul 08 2000 Dave Wreski <dave@linuxsecurity.com>
- Updated to version 1.6.2
- Removed references to xntpd
- Fixed minor problems with snortd init script

* Fri Jul 07 2000 Dave Wreski <dave@linuxsecurity.com>
- Updated to version 1.6.1
- Added user/group snort

* Sat Jun 10 2000 Dave Wreski <dave@linuxsecurity.com>
- Added snort init.d script (snortd)
- Added Dave Dittrich's snort rules header file (ruiles.base)
- Added Dave Dittrich's wget rules fetch script (check-snort)
- Fixed permissions on /var/log/snort
- Created /var/log/snort/archive for archival of snort logs
- Added post/preun to add/remove snortd to/from rc?.d directories
- Defined configuration files as %config

* Tue Mar 28 2000 William Stearns <wstearns@pobox.com>
- Quick update to 1.6.
- Sanity checks before doing rm-rf in install and clean

* Fri Dec 10 1999 Henri Gomez <gomez@slib.fr>
- 1.5-0 Initial RPM release
